From 74dd66f781248173acd4d26fd86d23146bc95748 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 13 2020 06:03:58 +0000
Subject: [PATCH 1723/2232] Import sys/types.h for ssize_t


Previously the header file generated for the following bridge did not
compile.

    #[cxx::bridge]
    mod ffi {
        struct S {
            x: isize,
        }
    }

    example-ecfac19134395bcc/out/cxxbridge/sources/example/src/main.rs.cc:15:15: error: ‘ssize_t’ does not name a type
       15 | using isize = ssize_t;
          |               ^~~~~~~
    example-ecfac19134395bcc/out/cxxbridge/sources/example/src/main.rs.cc:26:11: error: ‘isize’ in namespace ‘rust’ does not name a type
       26 |   ::rust::isize x;
          |           ^~~~~

---

diff --git a/gen/src/builtin.rs b/gen/src/builtin.rs
index be70a71..cee188d 100644
--- a/gen/src/builtin.rs
+++ b/gen/src/builtin.rs
@@ -93,6 +93,7 @@ pub(super) fn write(out: &mut OutFile) {
 
     if builtin.rust_isize {
         include.basetsd = true;
+        include.sys_types = true;
     }
 
     if builtin.relocatable {
diff --git a/gen/src/include.rs b/gen/src/include.rs
index 3a0d66b..6b7e580 100644
--- a/gen/src/include.rs
+++ b/gen/src/include.rs
@@ -37,6 +37,7 @@ pub struct Includes<'a> {
     pub utility: bool,
     pub vector: bool,
     pub basetsd: bool,
+    pub sys_types: bool,
     pub content: Content<'a>,
 }
 
@@ -88,6 +89,7 @@ pub(super) fn write(out: &mut OutFile) {
         utility,
         vector,
         basetsd,
+        sys_types,
         content: _,
     } = *include;
 
@@ -139,6 +141,18 @@ pub(super) fn write(out: &mut OutFile) {
     if basetsd {
         writeln!(out, "#if defined(_WIN32)");
         writeln!(out, "#include <basetsd.h>");
+    }
+    if sys_types {
+        if basetsd {
+            writeln!(out, "#else");
+        } else {
+            writeln!(out, "#if not defined(_WIN32)");
+        }
+    }
+    if sys_types {
+        writeln!(out, "#include <sys/types.h>");
+    }
+    if basetsd || sys_types {
         writeln!(out, "#endif");
     }
 }
diff --git a/include/cxx.h b/include/cxx.h
index 3ff671a..227b3fc 100644
--- a/include/cxx.h
+++ b/include/cxx.h
@@ -15,6 +15,8 @@
 #include <vector>
 #if defined(_WIN32)
 #include <basetsd.h>
+#else
+#include <sys/types.h>
 #endif
 
 namespace rust {

